package com.ejie.ab39a.dao;

import com.ejie.x38.dao.RowNumResultSetExtractor;
import com.ejie.x38.dto.JQGridManager;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.TableRowDto;
import com.gfi.constants.Constants;
import com.gfi.utils.UtilSQL;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import javax.annotation.Resource;
import javax.sql.DataSource;
import org.springframework.dao.support.DataAccessUtils;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab39a.constantes.Constantes;
import com.ejie.ab39a.constantes.SecuenciasSQL;
import com.ejie.ab39a.model.Planificacion;

/**
 * PlanificacionDaoImpl.
 * 
 *  
 */

@Repository
@Transactional
public class PlanificacionDaoImpl implements PlanificacionDao {

	private static final String[] ORDER_BY_WHITE_LIST = new String[] { "CODPLANIFICACION", "FECHAINICIO", "FECHAFIN",
			"DESCAS", "DESEUS", "BAJA" };

	private JdbcTemplate jdbcTemplate;

	/*
	 * ROW_MAPPERS
	 */
	private RowMapper<Planificacion> rwMap = new RowMapper<Planificacion>() {
		@Override
		public Planificacion mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			return new Planificacion(resultSet.getLong("CODPLANIFICACION"), resultSet.getInt("FECHAINICIO"),
					resultSet.getInt("FECHAFIN"), resultSet.getString("DESCAS"), resultSet.getString("DESEUS"),
					resultSet.getInt("BAJA"));
		}
	};
	private RowMapper<Planificacion> rwMapPe = new RowMapper<Planificacion>() {
		@Override
		public Planificacion mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			return new Planificacion(resultSet.getLong("CODPLANIFICACION"), resultSet.getInt("FECHAINICIO"),
					resultSet.getInt("FECHAFIN"), resultSet.getString("DESCAS"), resultSet.getString("DESEUS"),
					resultSet.getInt("BAJA"), resultSet.getString("CODPLANIFICACIONPE"));
		}
	};
	private RowMapper<Planificacion> rwMapFecha = new RowMapper<Planificacion>() {
		@Override
		public Planificacion mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			return new Planificacion(resultSet.getLong("CODPLANIFICACION"), resultSet.getInt("FECHAINICIO"),
					resultSet.getInt("FECHAFIN"));
		}
	};

	private RowMapper<Planificacion> rwMapPK = new RowMapper<Planificacion>() {
		@Override
		public Planificacion mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			return new Planificacion(resultSet.getLong("CODPLANIFICACION"));
		}
	};

	/**
	 * RowMapper para recoger el último registro
	 */
	private RowMapper<Planificacion> rwMapUltimoReg = new RowMapper<Planificacion>() {
		public Planificacion mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			Planificacion planif = new Planificacion();

			try {
				planif.setCodplanificacion(resultSet.getLong("IDMAX"));
			} catch (SQLException sqle) { /* no existe la columna */
			}

			return planif;

		}

	};

	/**
	 * Method use to set the datasource.
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	@Resource
	public void setDataSource(DataSource dataSource) {
		this.jdbcTemplate = new JdbcTemplate(dataSource);
	}

	/*
	 * OPERACIONES CRUD
	 */

	/**
	 * Inserts a single row in the Planificacion table.
	 *
	 * @param planificacion
	 *            Planificacion
	 * @return Planificacion
	 */
	@Override
	public Planificacion add(Planificacion planificacion) {
		StringBuilder query = new StringBuilder(
				"INSERT INTO PLANIFICACION (CODPLANIFICACION, FECHAINICIO, FECHAFIN, DESCAS, DESEUS, BAJA) VALUES (?,?,?,?,?,?)");

		Integer idPlanificacion = SecuenciasSQL.PLANIFICACION.getNextInteger(jdbcTemplate);
		planificacion.setCodplanificacion(new Long(idPlanificacion));

		planificacion.setBaja(Constantes.ALTA_LOGICA);

		this.jdbcTemplate.update(query.toString(), planificacion.getCodplanificacion(), planificacion.getFechainicio(),
				planificacion.getFechafin(), planificacion.getDescas(), planificacion.getDeseus(),
				planificacion.getBaja());
		return planificacion;
	}

	/**
	 * Updates a single row in the Planificacion table.
	 *
	 * @param planificacion
	 *            Planificacion
	 * @return Planificacion
	 */
	@Override
	public Planificacion update(Planificacion planificacion) {
		StringBuilder query = new StringBuilder(
				"UPDATE PLANIFICACION SET FECHAINICIO=?, FECHAFIN=?, DESCAS=?, DESEUS=?, BAJA=?");
		query.append(" WHERE CODPLANIFICACION=?");
		this.jdbcTemplate.update(query.toString(), planificacion.getFechainicio(), planificacion.getFechafin(),
				planificacion.getDescas(), planificacion.getDeseus(), planificacion.getBaja(),
				planificacion.getCodplanificacion());
		return planificacion;
	}

	/**
	 * Finds a single row in the Planificacion table.
	 *
	 * @param planificacion
	 *            Planificacion
	 * @return Planificacion
	 */
	@Override
	@Transactional(readOnly = true)
	public Planificacion find(Planificacion planificacion) {
		// SELECT - FROM
		StringBuilder query = new StringBuilder(this.getSelectFromQuery(true, false));
		// WHERE
		query.append(" WHERE t1.CODPLANIFICACION = ?  ");

		List<Planificacion> planificacionList = this.jdbcTemplate.query(query.toString(), this.rwMap,
				planificacion.getCodplanificacion());
		return DataAccessUtils.uniqueResult(planificacionList);
	}

	/**
	 * Removes a single row in the Planificacion table.Baja lógica
	 *
	 * @param planificacion
	 *            Planificacion
	 */
	@Override
	public void remove(Planificacion planificacion) {
		String query = "UPDATE PLANIFICACION SET BAJA=? WHERE CODPLANIFICACION=?";
		this.jdbcTemplate.update(query, Constantes.BAJA_LOGICA, planificacion.getCodplanificacion());

	}

	/**
	 * Finds a list of rows in the Planificacion table.
	 * 
	 * @param planificacion
	 *            Planificacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<Planificacion>
	 */
	@Override
	@Transactional(readOnly = true)
	public List<Planificacion> findAll(Planificacion planificacion, JQGridRequestDto jqGridRequestDto) {
		// SELECT - FROM
		StringBuilder query = new StringBuilder(this.getSelectFromQuery(true, false));

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(planificacion);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (jqGridRequestDto != null) {
			query = JQGridManager.getPaginationQuery(jqGridRequestDto, query, PlanificacionDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	/**
	 * Finds rows in the Planificacion table using like.
	 * 
	 * @param planificacion
	 *            Planificacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<Planificacion>
	 */
	@Override
	@Transactional(readOnly = true)
	public List<Planificacion> findAllLike(Planificacion planificacion, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		// SELECT - FROM
		boolean anio = false;
		StringBuilder query = new StringBuilder(this.getSelectFromQuery(true, true));

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(planificacion, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(" AND t2.CODPLANIFICACION(+)=t1.CODPLANIFICACION ");
		where.append(mapaWhere.get("query"));
		if (planificacion.getAnio() != null) {
			anio = true;
			where.append(" AND ?");
			where.append(" BETWEEN t1.FECHAINICIO AND t1.FECHAFIN ");
		}
		query.append(where);

		@SuppressWarnings("unchecked")
		List<Object> params = (List<Object>) mapaWhere.get("params");
		if (anio) {
			params.add(planificacion.getAnio());
		}
		if (jqGridRequestDto != null) {
			query = JQGridManager.getPaginationQuery(jqGridRequestDto, query, PlanificacionDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return this.jdbcTemplate.query(query.toString(), this.rwMapPe, params.toArray());
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Counts rows in the Planificacion table.
	 * 
	 * @param planificacion
	 *            Planificacion
	 * @return Long
	 */
	@Override
	@Transactional(readOnly = true)
	public Long findAllCount(Planificacion planificacion) {
		StringBuilder query = new StringBuilder("SELECT COUNT(1) FROM PLANIFICACION t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(planificacion);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Counts rows in the Planificacion table using like.
	 * 
	 * @param planificacion
	 *            Planificacion
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	@SuppressWarnings("unchecked")
	@Override
	@Transactional(readOnly = true)
	public Long findAllLikeCount(Planificacion planificacion, Boolean startsWith) {
		boolean anio = false;
		StringBuilder query = new StringBuilder("SELECT COUNT(1) FROM PLANIFICACION t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(planificacion, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		if (planificacion.getAnio() != null) {
			anio = true;
			where.append(" AND ?");
			where.append(" BETWEEN t1.FECHAINICIO AND t1.FECHAFIN ");
		}
		query.append(where);

		List<Object> params = (List<Object>) mapaWhere.get("params");

		if (anio) {
			params.add(planificacion.getAnio());
		}

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Reorder the data list of Planificacion selected for rup_table
	 * 
	 * @param planificacion
	 *            Planificacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<Planificacion>>
	 */
	@Override
	public List<TableRowDto<Planificacion>> reorderSelection(Planificacion planificacion,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		// SELECT - FROM
		StringBuilder query = new StringBuilder(this.getSelectFromQuery(true, false));

		// FILTRADO
		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(planificacion, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		// Parámetros de filtrado
		@SuppressWarnings(value = "unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhere.get("params");

		// SQL para la reordenación
		StringBuilder sbReorderSelectionSQL = JQGridManager.getReorderQuery(query, jqGridRequestDto,
				Planificacion.class, filterParamList, "CODPLANIFICACION");

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<Planificacion>(this.rwMapPK, jqGridRequestDto), filterParamList.toArray());
	}

	/**
	 * Remove multiple method for rup_table
	 * 
	 * @param filterPlanificacion
	 *            Planificacion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	@Override
	public void removeMultiple(Planificacion filterPlanificacion, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		// SELECT - FROM
		/** TODO: select por clave */
		StringBuilder query = new StringBuilder(this.getSelectFromQuery(true, false));

		// WHERE
		Map<String, Object> mapaWhere = this.getWhereLikeMap(filterPlanificacion, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		@SuppressWarnings(value = "unchecked")
		List<Object> params = (List<Object>) mapaWhere.get("params");

		StringBuilder sbRemoveMultipleSQL = JQGridManager.getRemoveMultipleQuery(jqGridRequestDto, Planificacion.class,
				query, params, "CODPLANIFICACION");
		this.jdbcTemplate.update(sbRemoveMultipleSQL.toString(), params.toArray());
	}

	/*
	 * MÉTODOS PRIVADOS
	 */

	/**
	 * Devuelve la Select con todos los campos. Incluye el From si se indica.
	 * 
	 * @param includeFrom
	 *            boolean
	 * @return String
	 */
	private String getSelectFromQuery(boolean includeFrom, boolean includeFiltro) {
		StringBuilder query = new StringBuilder("SELECT ");
		if (includeFiltro) {
			query.append(" DISTINCT ");
		}
		query.append(
				"t1.CODPLANIFICACION CODPLANIFICACION, t1.FECHAINICIO FECHAINICIO, t1.FECHAFIN FECHAFIN, t1.DESCAS DESCAS, t1.DESEUS DESEUS, t1.BAJA BAJA ");
		if (includeFiltro) {
			query.append(" ,t2.CODPLANIFICACION CODPLANIFICACIONPE ");
		}
		if (includeFrom) {
			query.append(" FROM PLANIFICACION t1 ");
		}
		if (includeFiltro) {
			query.append(" ,PLANES_ESTRATEGICOS t2 ");
		}
		return query.toString();
	}

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the Planificacion entity
	 * 
	 * @param planificacion
	 *            Planificacion Bean with the criteria values to filter by.
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, ?> getWhereMap(Planificacion planificacion) {

		StringBuilder where = new StringBuilder(Constants.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (planificacion != null) {
			if (planificacion.getCodplanificacion() != null) {
				UtilSQL.createFilterSQL(where, params, "t1.CODPLANIFICACION", planificacion.getCodplanificacion());
			}
			if (planificacion.getFechainicio() != null) {
				UtilSQL.createFilterSQL(where, params, "t1.FECHAINICIO", planificacion.getFechainicio());
			}
			if (planificacion.getFechafin() != null) {
				UtilSQL.createFilterSQL(where, params, "t1.FECHAFIN", planificacion.getFechafin());
			}
			if (planificacion.getDescas() != null) {
				UtilSQL.createFilterSQL(where, params, "t1.DESCAS", planificacion.getDescas());
			}
			if (planificacion.getDeseus() != null) {
				UtilSQL.createFilterSQL(where, params, "t1.DESEUS", planificacion.getDeseus());
			}
			if (planificacion.getBaja() != null) {
				UtilSQL.createFilterSQL(where, params, "t1.BAJA", planificacion.getBaja());
			}
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the Planificacion entity
	 * 
	 * @param planificacion
	 *            Planificacion Bean with the criteria values to filter by.
	 * @param startsWith
	 *            Boolean
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	private Map<String, Object> getWhereLikeMap(Planificacion planificacion, Boolean startsWith) {

		StringBuilder where = new StringBuilder(Constants.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (planificacion != null) {
			if (planificacion.getCodplanificacion() != null) {
				UtilSQL.createFilterLikeSQL(where, params, "t1.CODPLANIFICACION", planificacion.getCodplanificacion(),
						startsWith);
			}
			if (planificacion.getFechainicio() != null) {
				UtilSQL.createFilterLikeSQL(where, params, "t1.FECHAINICIO", planificacion.getFechainicio(),
						startsWith);
			}
			if (planificacion.getFechafin() != null) {
				UtilSQL.createFilterLikeSQL(where, params, "t1.FECHAFIN", planificacion.getFechafin(), startsWith);
			}
			if (planificacion.getDescas() != null) {
				UtilSQL.createFilterLikeSQL(where, params, "t1.DESCAS", planificacion.getDescas(), startsWith);
			}
			if (planificacion.getDeseus() != null) {
				UtilSQL.createFilterLikeSQL(where, params, "t1.DESEUS", planificacion.getDeseus(), startsWith);
			}
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}

	/**
	 * Método que devuelve el máximo id de la tabla Planificación
	 * 
	 * @return Integer
	 */
	@Override
	public Planificacion getMaxId() {
		StringBuilder query = new StringBuilder("SELECT MAX(t1.CODPLANIFICACION) IDMAX FROM PLANIFICACION t1");

		List<Planificacion> planificacionList = this.jdbcTemplate.query(query.toString(), this.rwMapUltimoReg);
		return (Planificacion) DataAccessUtils.uniqueResult(planificacionList);
	}

	/**
	 * Devuelve una objeto planificacion con lso años de la planificacion activa
	 *
	 * @return Planificacion Objeto con lso años de inicio y fin de la
	 *         planificacion activa
	 * 
	 */
	@Override
	public Planificacion getAnioPlanificacion() {
		StringBuilder query = new StringBuilder(
				"SELECT PL.FECHAINICIO FECHAINICIO, PL.FECHAFIN FECHAFIN, PL.CODPLANIFICACION CODPLANIFICACION FROM PLANIFICACION PL WHERE PL.BAJA = 0");

		List<Planificacion> planificacionList = this.jdbcTemplate.query(query.toString(), this.rwMapFecha);
		return (Planificacion) DataAccessUtils.uniqueResult(planificacionList);
	}
}
